package org.mapsforge.android.maps;

import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.graphics.drawable.Drawable;
import android.speech.tts.TextToSpeech;

public class ArrayItemizedTextAudioOverlay extends ArrayItemizedOverlayTweaked {
	protected final TextToSpeech tts_;
	protected AlertDialog dialogAlert;
	protected Drawable marker;

	public ArrayItemizedTextAudioOverlay(Drawable defaultMarker,
			Context context, TextToSpeech tts) {
		super(defaultMarker, context);
		tts_ = tts;
	}

	public ArrayItemizedTextAudioOverlay(Drawable defaultMarker, Context context) {
		super(defaultMarker, context);
		tts_ = null;
	}

	/*
	 * 21 -03 try to change the marker next need to override the method
	 * "drawonOvermap" --option 2
	 */
	public void setMarker(Drawable marker) {
		this.marker = boundCenterBottom(marker);
	}

	public Drawable getMarker() {
		return this.marker;
	}

	@Override
	public synchronized boolean onTap(int index) {
		this.item = this.overlayItems.get(index);
		// this.dialog = new AlertDialog.Builder(this.context);
		// this.dialog.setTitle(this.item.getTitle());
		// this.dialog.setMessage(this.item.getSnippet());
		// dialogAlert = this.dialog.show();
		//
		// return true;

		// OverlayItem item = createItem(index);
		if (item != null) {
			// System.out.println("ArrayItemizedTextAudioOverlay ontap");
			Builder builder = new AlertDialog.Builder(this.context);
			// builder.setIcon(android.R.drawable.ic_menu_info_details);
			builder.setTitle(item.getTitle());
			builder.setMessage(item.getSnippet());
			builder.setPositiveButton("OK", null);
			builder.show();
		}
		return true;

	}

	public synchronized boolean unTap() {

		// dialogAlert.cancel();
		// tts_.stop();
		return true;
	}
}
