package org.mapsforge.android.maps;

import org.tipple.mapDisplay.R;

import android.content.Context;
import android.text.method.ScrollingMovementMethod;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class MarkerPopup extends LinearLayout {

	private TextView title;
	private TextView snippet;
	private ImageView image;

	public MarkerPopup(MapView mapView) {
		super(mapView.getContext());
		setupPopup(mapView);
		this.setPadding(20, 10, 20, 10);
		this.setVisibility(View.GONE);
	}

	private void setupPopup(ViewGroup mapView) {
		LayoutInflater inflater = (LayoutInflater) mapView.getContext()
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		View view = inflater.inflate(R.layout.markerpopup, this);
		title = (TextView) view.findViewById(R.id.tTitle);
		title.setGravity(Gravity.BOTTOM | Gravity.FILL_HORIZONTAL);
		title.setTextColor(0xffffffff);
		title.setBackgroundColor(0xCC000000);
		title.setTextSize(14.0f);
		title.setVerticalScrollBarEnabled(true);
		title.setScrollBarStyle(View.SCROLLBARS_INSIDE_INSET);
		title.setMovementMethod(new ScrollingMovementMethod());
		image = (ImageView) view.findViewById(R.id.iPopupImage);
		image.setImageDrawable(null);

	}

	public void setData(OverlayMarkerItem item) {
		this.setVisibility(VISIBLE);
		setObjects(item);
	}

	private void setObjects(OverlayMarkerItem item) {
		if (item.getTitle() != null) {
			title.setVisibility(VISIBLE);
			String text_desc = item.getDescription();
			text_desc += "\n" + item.getContent();
			title.setText(text_desc);
			title.setSelected(true);
		} else {
			title.setText("");
			title.setVisibility(INVISIBLE);
		}
	}
}
