package org.tipple.mapDisplay;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLConnection;

import android.app.Activity;
import android.content.ContentValues;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Environment;
import android.provider.MediaStore;
import android.util.Log;

public class ImageLoader extends AsyncTask<String, Integer, Bitmap> {

	private final String TAG = null;
	public String myurl;
	Context context;
	String name;

	public ImageLoader(Activity context) {
		this.context = context;
	}

	public void download(String url) {
		myurl = null;
		myurl = url;
		String[] imageName = myurl.split("\\/");
		String finalName = imageName[11].replaceAll("%20", " ");
		name = "/sdcard/" + finalName;
		File file = new File(name);
		if (file.exists()) {
			System.out.println("File exists");
			return;
		} else
			this.execute(myurl);
	}

	@Override
	protected Bitmap doInBackground(String... params) {
		return downloadAvatar(params[0]);

	}

	public Bitmap downloadAvatar(String url) {
		Bitmap bm = null;
		try {
			URL aURL = new URL(url);
			URLConnection conn = aURL.openConnection();
			conn.connect();
			InputStream is = conn.getInputStream();
			BufferedInputStream bis = new BufferedInputStream(is);
			bm = BitmapFactory.decodeStream(bis);
			bis.close();
			is.close();
		}

		catch (Exception e) {
			Log.w("AvatarDownloader", "Error while ...retrieving bitmap from "
					+ url);
		}

		return bm;

	}

	String imageDirectory;

	protected void onPostExecute(Bitmap result) {
		String rname = "/sdcard/" + myurl.toString().hashCode() + "-t.jpg";
		try {
			if (result != null) {
				hasExternalStoragePublicPicture(name);
				Bitmap rezised = this.resizeBitmap(result, 300, 300);
				saveToSDCard(result, name, myurl.toString().hashCode() + ".jpg");
				result.recycle();
				rezised.recycle();

			} else {
				System.out.println("onPostExecute... already exist");

			}
		} catch (NullPointerException e) {
			System.out.println("onPostExecute...unsuccessfully download ");
		}

	}

	private boolean hasExternalStoragePublicPicture(String name) {
		File file = new File(name);
		if (file != null) {
			file.delete();
		}

		try {
			file.createNewFile();

		} catch (IOException e) {
			e.printStackTrace();

		}
		return file.exists();
	}

	public void saveToSDCard(Bitmap bitmap, String name, String nam) {
		boolean mExternalStorageAvailable = false;
		boolean mExternalStorageWriteable = false;
		String state = Environment.getExternalStorageState();
		if (Environment.MEDIA_MOUNTED.equals(state)) {
			mExternalStorageAvailable = mExternalStorageWriteable = true;
			Log.v(TAG, "SD Card is available for read and write "
					+ mExternalStorageAvailable + mExternalStorageWriteable);
			saveFile(bitmap, name, nam);
		} else if (Environment.MEDIA_MOUNTED_READ_ONLY.equals(state)) {
			mExternalStorageAvailable = true;
			mExternalStorageWriteable = false;
			Log.v(TAG, "SD Card is available for read "
					+ mExternalStorageAvailable);
		} else {
			mExternalStorageAvailable = mExternalStorageWriteable = false;
			Log.v(TAG, "Please insert a SD Card to save your Video "
					+ mExternalStorageAvailable + mExternalStorageWriteable);
		}
	}

	private void saveFile(Bitmap bitmap, String fullname, String nam) {

		ContentValues values = new ContentValues();

		File outputFile = new File(fullname);
		values.put(MediaStore.MediaColumns.DATA, outputFile.toString());
		values.put(MediaStore.MediaColumns.TITLE, nam);
		values.put(MediaStore.MediaColumns.DATE_ADDED,
				System.currentTimeMillis());
		values.put(MediaStore.MediaColumns.MIME_TYPE, "image/jpg");
		Uri uri = context.getContentResolver().insert(
				android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI,

				values);
		;

		try {
			OutputStream outStream = context.getContentResolver()
					.openOutputStream(uri);
			bitmap.compress(Bitmap.CompressFormat.JPEG, 95, outStream);

			outStream.flush();
			outStream.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		bitmap.recycle();

	}

	public Bitmap resizeBitmap(Bitmap result, int i, int j) {
		// TODO Auto-generated method stub
		int width = result.getWidth();
		int height = result.getHeight();
		int newWidth = 1;
		int newHeight = j;
		float scaleWidth = ((float) newWidth) / width;
		float scaleHeight = ((float) newHeight) / height;
		Matrix matrix = new Matrix();
		matrix.postScale(scaleWidth, scaleHeight);
		// create the new Bitmap
		Bitmap resizedBitmap = Bitmap.createBitmap(result, 0, 0, width, height,
				matrix, true);
		return resizedBitmap;
	}
}
